<Query Kind="Program">
  <Reference>&lt;RuntimeDirectory&gt;\System.Net.dll</Reference>
  <Reference>&lt;RuntimeDirectory&gt;\System.XML.dll</Reference>
  <NuGetReference>ICSharpCode.SharpZipLib.dll</NuGetReference>
  <Namespace>ICSharpCode.SharpZipLib</Namespace>
  <Namespace>ICSharpCode.SharpZipLib.BZip2</Namespace>
  <Namespace>ICSharpCode.SharpZipLib.Checksums</Namespace>
  <Namespace>ICSharpCode.SharpZipLib.Core</Namespace>
  <Namespace>ICSharpCode.SharpZipLib.Encryption</Namespace>
  <Namespace>ICSharpCode.SharpZipLib.GZip</Namespace>
  <Namespace>ICSharpCode.SharpZipLib.Tar</Namespace>
  <Namespace>ICSharpCode.SharpZipLib.Zip</Namespace>
  <Namespace>ICSharpCode.SharpZipLib.Zip.Compression</Namespace>
  <Namespace>ICSharpCode.SharpZipLib.Zip.Compression.Streams</Namespace>
  <Namespace>System.Net</Namespace>
  <Namespace>System.Xml.Serialization</Namespace>
</Query>

void Main()
{
	// bigbluebrains:yellowbox
	String username = "bigbluebrains"; 
	String password = "yellowbox";
	String url = "http://www.ebroadcast.com.au/datafeeds/apps/tv_fta/meta.xml";
	
	HttpWebRequest request = (HttpWebRequest)WebRequest.Create(url);
	
	String encoded = System.Convert.ToBase64String(System.Text.Encoding.GetEncoding("ISO-8859-1").GetBytes(username + ":" + password));
	request.Headers.Add("Authorization", "Basic " + encoded);
	HttpWebResponse response = (HttpWebResponse)request.GetResponse();
	Stream receiveStream = response.GetResponseStream ();
	StreamReader readStream = new StreamReader (receiveStream, Encoding.UTF8);
	string xml = readStream.ReadToEnd ();
	response.Close ();
	readStream.Close ();
//	xml.Dump();
	
    var tvguide_meta = xml.ParseXML<tvguide_meta>();
//	tvguide_meta.Dump();
	var dates = tvguide_meta.date.Select (d => d.v).ToList();
//	dates.Dump();
//	return;
	foreach (var date in dates) {
		string dateAsString = date.ToString();
		if (dateAsString.Length == 7) dateAsString = "0" + dateAsString;
		url = string.Format("http://www.ebroadcast.com.au/datafeeds/apps/tv_fta/bystate/perth/{0}.xml.zip", dateAsString);
		request = (HttpWebRequest)WebRequest.Create(url);
		encoded = System.Convert.ToBase64String(System.Text.Encoding.GetEncoding("ISO-8859-1").GetBytes(username + ":" + password));
		request.Headers.Add("Authorization", "Basic " + encoded);
		response = (HttpWebResponse)request.GetResponse();
		receiveStream = response.GetResponseStream ();
		MemoryStream ms = new MemoryStream();
		receiveStream.CopyTo(ms);
		ms.Position = 0;
//		byte[] byteArray = ms.ToArray();
		var zipInputStream = new ZipInputStream(ms);
//		zipStream.Dump();
		ZipEntry zipEntry = zipInputStream.GetNextEntry();
//		zipEntry.Dump();
		var zipfile = new ZipFile(ms);
		Stream s = zipfile.GetInputStream(zipEntry);
        var byteArray = new byte[zipEntry.Size];
        s.Read(byteArray, 0, byteArray.Length);
		xml = System.Text.Encoding.Default.GetString(byteArray);
//		xml.Dump();
		
		var tvguide = xml.ParseXML<tvguide>();
		tvguide.Dump();

	
	
	}
}

// Define other methods and classes here

// ----------------------------------------------------------------------------------------- tvguide_meta ----------------------------------------------

/// <remarks/>
[System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true)]
[System.Xml.Serialization.XmlRootAttribute(Namespace="", IsNullable=false)]
public partial class tvguide_meta {
    
    private tvguide_metaDate[] dateField;
    
    /// <remarks/>
    [System.Xml.Serialization.XmlElementAttribute("date")]
    public tvguide_metaDate[] date {
        get {
            return this.dateField;
        }
        set {
            this.dateField = value;
        }
    }
}

/// <remarks/>
[System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true)]
public partial class tvguide_metaDate {
    
    private uint vField;
    
    private string timestampField;
    
    /// <remarks/>
    [System.Xml.Serialization.XmlAttributeAttribute()]
    public uint v {
        get {
            return this.vField;
        }
        set {
            this.vField = value;
        }
    }
    
    /// <remarks/>
    [System.Xml.Serialization.XmlAttributeAttribute()]
    public string timestamp {
        get {
            return this.timestampField;
        }
        set {
            this.timestampField = value;
        }
    }
}


// ---------------------------------------------------------------------------------- end tvguide_meta ------------------------------------------------------------------------

/// <remarks/>
[System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true)]
[System.Xml.Serialization.XmlRootAttribute(Namespace="", IsNullable=false)]
public partial class tvguide {
    
    private tvguideCity cityField;
    
    /// <remarks/>
    public tvguideCity city {
        get {
            return this.cityField;
        }
        set {
            this.cityField = value;
        }
    }
}

/// <remarks/>
[System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true)]
public partial class tvguideCity {
    
    private tvguideCityCH[] chField;
    
    private string vField;
    
    private uint dField;
    
    /// <remarks/>
    [System.Xml.Serialization.XmlElementAttribute("ch")]
    public tvguideCityCH[] ch {
        get {
            return this.chField;
        }
        set {
            this.chField = value;
        }
    }
    
    /// <remarks/>
    [System.Xml.Serialization.XmlAttributeAttribute()]
    public string v {
        get {
            return this.vField;
        }
        set {
            this.vField = value;
        }
    }
    
    /// <remarks/>
    [System.Xml.Serialization.XmlAttributeAttribute()]
    public uint d {
        get {
            return this.dField;
        }
        set {
            this.dField = value;
        }
    }
}

/// <remarks/>
[System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true)]
public partial class tvguideCityCH {
    
    private tvguideCityCHT[] tField;
    
    private string vField;
    
    /// <remarks/>
    [System.Xml.Serialization.XmlElementAttribute("t")]
    public tvguideCityCHT[] t {
        get {
            return this.tField;
        }
        set {
            this.tField = value;
        }
    }
    
    /// <remarks/>
    [System.Xml.Serialization.XmlAttributeAttribute()]
    public string v {
        get {
            return this.vField;
        }
        set {
            this.vField = value;
        }
    }
}

/// <remarks/>
[System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true)]
public partial class tvguideCityCHT {
    
    private string dField;
    
    private string lField;
    
    private string rField;
    
    private string cField;
    
    private string vField;
    
    private string eField;
    
    private byte pField;
    
    private byte oField;
    
    private bool oFieldSpecified;
    
    /// <remarks/>
    [System.Xml.Serialization.XmlAttributeAttribute()]
    public string d {
        get {
            return this.dField;
        }
        set {
            this.dField = value;
        }
    }
    
    /// <remarks/>
    [System.Xml.Serialization.XmlAttributeAttribute()]
    public string l {
        get {
            return this.lField;
        }
        set {
            this.lField = value;
        }
    }
    
    /// <remarks/>
    [System.Xml.Serialization.XmlAttributeAttribute()]
    public string r {
        get {
            return this.rField;
        }
        set {
            this.rField = value;
        }
    }
    
    /// <remarks/>
    [System.Xml.Serialization.XmlAttributeAttribute()]
    public string c {
        get {
            return this.cField;
        }
        set {
            this.cField = value;
        }
    }
    
    /// <remarks/>
    [System.Xml.Serialization.XmlAttributeAttribute()]
    public string v {
        get {
            return this.vField;
        }
        set {
            this.vField = value;
        }
    }
    
    /// <remarks/>
    [System.Xml.Serialization.XmlAttributeAttribute()]
    public string e {
        get {
            return this.eField;
        }
        set {
            this.eField = value;
        }
    }
    
    /// <remarks/>
    [System.Xml.Serialization.XmlAttributeAttribute()]
    public byte p {
        get {
            return this.pField;
        }
        set {
            this.pField = value;
        }
    }
    
    /// <remarks/>
    [System.Xml.Serialization.XmlAttributeAttribute()]
    public byte o {
        get {
            return this.oField;
        }
        set {
            this.oField = value;
        }
    }
    
    /// <remarks/>
    [System.Xml.Serialization.XmlIgnoreAttribute()]
    public bool oSpecified {
        get {
            return this.oFieldSpecified;
        }
        set {
            this.oFieldSpecified = value;
        }
    }
}



public static class Extensions {
	public static Stream ToStream(this string @this)
        {
            var stream = new MemoryStream();
            var writer = new StreamWriter(stream);
            writer.Write(@this);
            writer.Flush();
            stream.Position = 0;
            return stream;
        }


        public static T ParseXML<T>(this string @this) where T : class
        {
            var reader = XmlReader.Create(@this.Trim().ToStream(), new XmlReaderSettings() { 
//				ConformanceLevel = ConformanceLevel.Document 
				ConformanceLevel = ConformanceLevel.Fragment
			});
            return new XmlSerializer(typeof(T)).Deserialize(reader) as T;
        }
}